diff -uNr unrar/unicode.cpp unrar/unicode.cpp
--- unrar/unicode.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/unicode.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -16,7 +16,10 @@
 #else
 #ifdef MBFUNCTIONS
 
-  if (wcstombs(Dest,Src,DestSize)==(size_t)-1)
+  size_t ResultingSize=wcstombs(Dest,Src,DestSize);
+  if (ResultingSize==(size_t)-1)
+    RetCode=false;
+  if (ResultingSize==0 && *Src!=0)
     RetCode=false;
 
   if ((!RetCode || *Dest==0 && *Src!=0) && DestSize>NM && strlenw(Src)<NM)
@@ -66,7 +69,10 @@
 #else
 #ifdef MBFUNCTIONS
 
-  if (mbstowcs(Dest,Src,DestSize)==(size_t)-1)
+  size_t ResultingSize=mbstowcs(Dest,Src,DestSize);
+  if (ResultingSize==(size_t)-1)
+    RetCode=false;
+  if (ResultingSize==0 && *Src!=0)
     RetCode=false;
 
   if ((!RetCode || *Dest==0 && *Src!=0) && DestSize>NM && strlen(Src)<NM)
@@ -241,11 +247,11 @@
 }
 
 
-wchar* strncpyw(wchar *dest,const wchar *src,int n)
+wchar* strncpyw(wchar *dest,const wchar *src,size_t n)
 {
   do {
     *(dest++)=*src;
-  } while (*(src++)!=0 && --n > 0);
+  } while (*(src++)!=0 && (int)(--n) > 0);
   return(dest);
 }
 
@@ -257,11 +263,11 @@
 
 
 #ifndef SFX_MODULE
-wchar* strncatw(wchar *dest,const wchar *src,int n)
+wchar* strncatw(wchar *dest,const wchar *src,size_t n)
 {
   dest+=strlenw(dest);
   while (true)
-    if (--n<0)
+    if ((int)(--n)<0)
     {
       *dest=0;
       break;
@@ -287,9 +293,9 @@
 }
 
 
-int strncmpw(const wchar *s1,const wchar *s2,int n)
+int strncmpw(const wchar *s1,const wchar *s2,size_t n)
 {
-  while (n-->0)
+  while ((int)(n--)>0)
   {
     if (*s1<*s2)
       return(-1);
@@ -316,7 +322,7 @@
 
 
 #if !defined(SFX_MODULE) && !defined(_WIN_CE)
-inline int strnicmpw_w2c(const wchar *s1,const wchar *s2,int n)
+inline int strnicmpw_w2c(const wchar *s1,const wchar *s2,size_t n)
 {
   wchar Wide1[NM*2],Wide2[NM*2];
   strncpyw(Wide1,s1,sizeof(Wide1)/sizeof(Wide1[0])-1);
@@ -332,7 +338,7 @@
 
 
 #ifndef SFX_MODULE
-int strnicmpw(const wchar *s1,const wchar *s2,int n)
+int strnicmpw(const wchar *s1,const wchar *s2,size_t n)
 {
   return(strnicmpw_w2c(s1,s2,n));
 }
@@ -395,6 +401,20 @@
 
 
 #ifndef SFX_MODULE
+wchar* strdupw(const wchar *Str)
+{
+  if (Str==NULL)
+    return(NULL);
+  wchar *n=(wchar *)malloc((strlenw(Str)+1)*sizeof(wchar));
+  if (n==NULL)
+    return(NULL);
+  strcpyw(n,Str);
+  return(n);
+}
+#endif
+
+
+#ifndef SFX_MODULE
 int toupperw(int ch)
 {
   return((ch<128) ? loctoupper(ch):ch);
diff -uNr unrar/unicode.hpp unrar/unicode.hpp
--- unrar/unicode.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/unicode.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -28,18 +28,19 @@
 
 int strlenw(const wchar *str);
 wchar* strcpyw(wchar *dest,const wchar *src);
-wchar* strncpyw(wchar *dest,const wchar *src,int n);
+wchar* strncpyw(wchar *dest,const wchar *src,size_t n);
 wchar* strcatw(wchar *dest,const wchar *src);
-wchar* strncatw(wchar *dest,const wchar *src,int n);
+wchar* strncatw(wchar *dest,const wchar *src,size_t n);
 int strcmpw(const wchar *s1,const wchar *s2);
-int strncmpw(const wchar *s1,const wchar *s2,int n);
+int strncmpw(const wchar *s1,const wchar *s2,size_t n);
 int stricmpw(const wchar *s1,const wchar *s2);
-int strnicmpw(const wchar *s1,const wchar *s2,int n);
+int strnicmpw(const wchar *s1,const wchar *s2,size_t n);
 wchar *strchrw(const wchar *s,int c);
 wchar* strrchrw(const wchar *s,int c);
 wchar* strpbrkw(const wchar *s1,const wchar *s2);
 wchar* strlowerw(wchar *Str);
 wchar* strupperw(wchar *Str);
+wchar* strdupw(const wchar *Str);
 int toupperw(int ch);
 int atoiw(const wchar *s);
 
diff -uNr unrar/unpack.cpp unrar/unpack.cpp
--- unrar/unpack.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/unpack.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -262,6 +262,11 @@
           }
           if (Failed)
             break;
+
+#ifdef _MSC_VER
+  // avoid a warning about uninitialized 'Length' variable
+  #pragma warning( disable : 4701 )
+#endif
           CopyString(Length+32,Distance+2);
           continue;
         }
diff -uNr unrar/uowners.cpp unrar/uowners.cpp
--- unrar/uowners.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/uowners.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -5,7 +5,7 @@
   if (Arc.HeaderCRC!=Arc.UOHead.HeadCRC)
   {
     Log(Arc.FileName,St(MOwnersBroken),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
@@ -13,7 +13,7 @@
   if ((pw=getpwnam(Arc.UOHead.OwnerName))==NULL)
   {
     Log(Arc.FileName,St(MErrGetOwnerID),Arc.UOHead.OwnerName);
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
     return;
   }
   uid_t OwnerID=pw->pw_uid;
@@ -22,7 +22,7 @@
   if ((gr=getgrnam(Arc.UOHead.GroupName))==NULL)
   {
     Log(Arc.FileName,St(MErrGetGroupID),Arc.UOHead.GroupName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
   uint Attr=GetFileAttr(FileName,NULL);
@@ -34,7 +34,7 @@
 #endif
   {
     Log(Arc.FileName,St(MSetOwnersError),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CREATE_ERROR);
   }
   SetFileAttr(FileName,NULL,Attr);
 }
@@ -53,7 +53,7 @@
   if ((pw=getpwnam(OwnerName))==NULL)
   {
     Log(Arc.FileName,St(MErrGetOwnerID),OwnerName);
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
     return;
   }
   uid_t OwnerID=pw->pw_uid;
@@ -62,7 +62,7 @@
   if ((gr=getgrnam(GroupName))==NULL)
   {
     Log(Arc.FileName,St(MErrGetGroupID),GroupName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
   uint Attr=GetFileAttr(FileName,NULL);
@@ -74,7 +74,7 @@
 #endif
   {
     Log(Arc.FileName,St(MSetOwnersError),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CREATE_ERROR);
   }
   SetFileAttr(FileName,NULL,Attr);
 }
diff -uNr unrar/version.hpp unrar/version.hpp
--- unrar/version.hpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/version.hpp	2008-10-24 06:44:48.000000000 +0200
@@ -1,6 +1,6 @@
 #define RARVER_MAJOR     3
-#define RARVER_MINOR    71
-#define RARVER_BETA      1
-#define RARVER_DAY      10
+#define RARVER_MINOR    80
+#define RARVER_BETA      0
+#define RARVER_DAY      16
 #define RARVER_MONTH     9
-#define RARVER_YEAR   2007
+#define RARVER_YEAR   2008
diff -uNr unrar/volume.cpp unrar/volume.cpp
--- unrar/volume.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/volume.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -19,39 +19,17 @@
   }
 
   Int64 PosBeforeClose=Arc.Tell();
+
+  if (DataIO!=NULL)
+    DataIO->ProcessedArcSize+=Arc.FileLength();
+
   Arc.Close();
 
   char NextName[NM];
   wchar NextNameW[NM];
-  *NextNameW=0;
   strcpy(NextName,Arc.FileName);
-  NextVolumeName(NextName,(Arc.NewMhd.Flags & MHD_NEWNUMBERING)==0 || Arc.OldFormat);
-
-  if (*Arc.FileNameW!=0)
-  {
-    // Copy incremented trailing low ASCII volume name part to Unicode name.
-    // It is simpler than also implementing Unicode version of NextVolumeName.
-
-    strcpyw(NextNameW,Arc.FileNameW);
-    char *NumPtr=GetVolNumPart(NextName);
-
-    // moving to first digit in volume number
-    while (NumPtr>NextName && isdigit(*NumPtr) && isdigit(*(NumPtr-1)))
-      NumPtr--;
-
-    // also copy the first character before volume number,
-    // because it can be changed when going from .r99 to .s00
-    if (NumPtr>NextName)
-      NumPtr--;
-
-    int CharsToCopy=strlen(NextName)-(NumPtr-NextName);
-    int DestPos=strlenw(NextNameW)-CharsToCopy;
-    if (DestPos>0)
-    {
-      CharToWide(NumPtr,NextNameW+DestPos,ASIZE(NextNameW)-DestPos-1);
-      NextNameW[ASIZE(NextNameW)-1]=0;
-    }
-  }
+  strcpyw(NextNameW,Arc.FileNameW);
+  NextVolumeName(NextName,NextNameW,ASIZE(NextName),(Arc.NewMhd.Flags & MHD_NEWNUMBERING)==0 || Arc.OldFormat);
 
 #if !defined(SFX_MODULE) && !defined(RARDLL)
   bool RecoveryDone=false;
@@ -60,22 +38,33 @@
 
   while (!Arc.Open(NextName,NextNameW))
   {
+    // We need to open a new volume which size was not calculated
+    // in total size before, so we cannot calculate the total progress
+    // anymore. Let's reset the total size to zero and stop 
+    // the total progress.
+    if (DataIO!=NULL)
+      DataIO->TotalArcSize=0;
+
     if (!OldSchemeTested)
     {
+      // Checking for new style volumes renamed by user to old style
+      // name format. Some users did it for unknown reason.
       char AltNextName[NM];
+      wchar AltNextNameW[NM];
       strcpy(AltNextName,Arc.FileName);
-      NextVolumeName(AltNextName,true);
+      strcpyw(AltNextNameW,Arc.FileNameW);
+      NextVolumeName(AltNextName,AltNextNameW,ASIZE(AltNextName),true);
       OldSchemeTested=true;
-      if (Arc.Open(AltNextName))
+      if (Arc.Open(AltNextName,AltNextNameW))
       {
         strcpy(NextName,AltNextName);
-        *NextNameW=0;
+        strcpyw(NextNameW,AltNextNameW);
         break;
       }
     }
 #ifdef RARDLL
     if (Cmd->Callback==NULL && Cmd->ChangeVolProc==NULL ||
-        Cmd->Callback!=NULL && Cmd->Callback(UCM_CHANGEVOLUME,Cmd->UserData,(LONG)NextName,RAR_VOL_ASK)==-1)
+        Cmd->Callback!=NULL && Cmd->Callback(UCM_CHANGEVOLUME,Cmd->UserData,(LPARAM)NextName,RAR_VOL_ASK)==-1)
     {
       Cmd->DllError=ERAR_EOPEN;
       FailedOpen=true;
@@ -123,6 +112,7 @@
       FailedOpen=true;
       break;
     }
+
 #endif // RARDLL
     *NextNameW=0;
   }
@@ -138,7 +128,7 @@
   Arc.CheckArc(true);
 #ifdef RARDLL
   if (Cmd->Callback!=NULL &&
-      Cmd->Callback(UCM_CHANGEVOLUME,Cmd->UserData,(LONG)NextName,RAR_VOL_NOTIFY)==-1)
+      Cmd->Callback(UCM_CHANGEVOLUME,Cmd->UserData,(LPARAM)NextName,RAR_VOL_NOTIFY)==-1)
     return(false);
   if (Cmd->ChangeVolProc!=NULL)
   {
@@ -197,8 +187,13 @@
     }
 #ifdef SFX_MODULE
     DataIO->UnpArcSize=Arc.FileLength();
-    DataIO->CurUnpRead=0;
 #endif
+    
+    // Reset the size of packed data read from current volume. It is used
+    // to display the total progress and preceding volumes are already
+    // compensated with ProcessedArcSize, so we need to reset this variable.
+    DataIO->CurUnpRead=0;
+
     DataIO->PackedCRC=0xffffffff;
 //    DataIO->SetFiles(&Arc,NULL);
   }
diff -uNr unrar/win32acl.cpp unrar/win32acl.cpp
--- unrar/win32acl.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/win32acl.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -15,14 +15,14 @@
   if (Arc.HeaderCRC!=Arc.EAHead.HeadCRC)
   {
     Log(Arc.FileName,St(MACLBroken),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
   if (Arc.EAHead.Method<0x31 || Arc.EAHead.Method>0x35 || Arc.EAHead.UnpVer>PACK_VER)
   {
     Log(Arc.FileName,St(MACLUnknown),FileName);
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
     return;
   }
 
@@ -41,7 +41,7 @@
   if (Arc.EAHead.EACRC!=~DataIO.UnpFileCRC)
   {
     Log(Arc.FileName,St(MACLBroken),FileName);
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
@@ -61,7 +61,7 @@
   {
     Log(Arc.FileName,St(MACLSetError),FileName);
     ErrHandler.SysErrMsg();
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
   }
 }
 #endif
@@ -94,7 +94,7 @@
   {
     Log(Arc.FileName,St(MACLSetError),FileName);
     ErrHandler.SysErrMsg();
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
   }
 }
 
diff -uNr unrar/win32stm.cpp unrar/win32stm.cpp
--- unrar/win32stm.cpp	2008-02-26 14:28:59.000000000 +0100
+++ unrar/win32stm.cpp	2008-10-24 06:44:48.000000000 +0200
@@ -12,7 +12,7 @@
 #ifndef SILENT
     Log(Arc.FileName,St(MStreamBroken),FileName);
 #endif
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
@@ -21,7 +21,7 @@
 #ifndef SILENT
     Log(Arc.FileName,St(MStreamUnknown),FileName);
 #endif
-    ErrHandler.SetErrorCode(RAR_WARNING);
+    ErrHandler.SetErrorCode(WARNING);
     return;
   }
 
@@ -39,7 +39,7 @@
 #ifndef SILENT
     Log(Arc.FileName,St(MStreamBroken),FileName);
 #endif
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
@@ -72,7 +72,7 @@
 #ifndef SILENT
       Log(Arc.FileName,St(MStreamBroken),StreamName);
 #endif
-      ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+      ErrHandler.SetErrorCode(CRC_ERROR);
     }
     else
       CurFile.Close();
@@ -115,7 +115,7 @@
 #if !defined(SILENT) && !defined(SFX_MODULE)
     Log(Arc.FileName,St(MStreamBroken),FileName);
 #endif
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
@@ -127,7 +127,7 @@
 #if !defined(SILENT) && !defined(SFX_MODULE)
     Log(Arc.FileName,St(MStreamBroken),FileName);
 #endif
-    ErrHandler.SetErrorCode(RAR_CRC_ERROR);
+    ErrHandler.SetErrorCode(CRC_ERROR);
     return;
   }
 
